diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ap-wifi-mac.cc ns-3.34/src/wifi/model/ap-wifi-mac.cc
--- ns-3.33/src/wifi/model/ap-wifi-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ap-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -1312,57 +1157,16 @@
               m_stationManager->AddSupportedPhyPreamble (from, capabilities.IsShortPreamble ());
               SupportedRates rates = reassocReq.GetSupportedRates ();
               bool problem = false;
-              bool isHtStation = false;
-              bool isOfdmStation = false;
-              bool isErpStation = false;
-              bool isDsssStation = false;
-              for (uint8_t i = 0; i < m_stationManager->GetNBasicModes (); i++)
+              if (rates.GetNRates () == 0)
                 {
-                  WifiMode mode = m_stationManager->GetBasicMode (i);
-                  if (!rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth ())))
-                    {
-                      if ((mode.GetModulationClass () == WIFI_MOD_CLASS_DSSS) || (mode.GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS))
-                        {
-                          isDsssStation = false;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM)
-                        {
-                          isErpStation = false;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM)
-                        {
-                          isOfdmStation = false;
-                        }
-                      if (isDsssStation == false && isErpStation == false && isOfdmStation == false)
-                        {
-                          problem = true;
-                          break;
-                        }
-                    }
-                  else
-                    {
-                      if ((mode.GetModulationClass () == WIFI_MOD_CLASS_DSSS) || (mode.GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS))
-                        {
-                          isDsssStation = true;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM)
-                        {
-                          isErpStation = true;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM)
-                        {
-                          isOfdmStation = true;
-                        }
-                    }
+                  problem = true;
                 }
-              m_stationManager->AddSupportedErpSlotTime (from, capabilities.IsShortSlotTime () && isErpStation);
               if (GetHtSupported ())
                 {
                   //check whether the HT STA supports all MCSs in Basic MCS Set
                   HtCapabilities htcapabilities = reassocReq.GetHtCapabilities ();
                   if (htcapabilities.IsSupportedMcs (0))
                     {
-                      isHtStation = true;
                       for (uint8_t i = 0; i < m_stationManager->GetNBasicMcs (); i++)
                         {
                           WifiMode mcs = m_stationManager->GetBasicMcs (i);
@@ -1417,14 +1221,17 @@
                 {
                   NS_LOG_DEBUG ("The Basic Rate set modes are supported by the station");
                   //update all its supported modes in its associated WifiRemoteStation
-                  for (uint8_t j = 0; j < m_phy->GetNModes (); j++)
+                  for (const auto & mode : m_phy->GetModeList ())
                     {
-                      WifiMode mode = m_phy->GetMode (j);
                       if (rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth ())))
                         {
                           m_stationManager->AddSupportedMode (from, mode);
                         }
                     }
+                  if (GetErpSupported () && m_stationManager->GetErpOfdmSupported (from) && capabilities.IsShortSlotTime ())
+                    {
+                      m_stationManager->AddSupportedErpSlotTime (from, true);
+                    }
                   if (GetHtSupported ())
                     {
                       HtCapabilities htCapabilities = reassocReq.GetHtCapabilities ();
@@ -1440,10 +1247,9 @@
                       if (vhtCapabilities.GetRxHighestSupportedLgiDataRate () > 0)
                         {
                           m_stationManager->AddStationVhtCapabilities (from, vhtCapabilities);
-                          for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
+                          for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_VHT))
                             {
-                              WifiMode mcs = m_phy->GetMcs (i);
-                              if (mcs.GetModulationClass () == WIFI_MOD_CLASS_VHT && vhtCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
+                              if (vhtCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
                                 {
                                   m_stationManager->AddSupportedMcs (hdr->GetAddr2 (), mcs);
                                   //here should add a control to add basic MCS when it is implemented
@@ -1462,10 +1268,9 @@
                       if (heCapabilities.GetSupportedMcsAndNss () != 0)
                         {
                           m_stationManager->AddStationHeCapabilities (from, heCapabilities);
-                          for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
+                          for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_HE))
                             {
-                              WifiMode mcs = m_phy->GetMcs (i);
-                              if (mcs.GetModulationClass () == WIFI_MOD_CLASS_HE && heCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
+                              if (heCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
                                 {
                                   m_stationManager->AddSupportedMcs (hdr->GetAddr2 (), mcs);
                                   //here should add a control to add basic MCS when it is implemented
@@ -1474,16 +1279,6 @@
                         }
                     }
                   m_stationManager->RecordWaitAssocTxOk (from);
-                  if (!isHtStation)
-                    {
-                      m_nonHtStations.push_back (hdr->GetAddr2 ());
-                      m_nonHtStations.unique ();
-                    }
-                  if (!isErpStation && isDsssStation)
-                    {
-                      m_nonErpStations.push_back (hdr->GetAddr2 ());
-                      m_nonErpStations.unique ();
-                    }
                   NS_LOG_DEBUG ("Send reassociation response with success status");
                   SendAssocResp (hdr->GetAddr2 (), true, true);
                 }
@@ -1493,35 +1288,23 @@
             {
               NS_LOG_DEBUG ("Disassociation received from " << from);
               m_stationManager->RecordDisassociated (from);
-              for (std::map<uint16_t, Mac48Address>::const_iterator j = m_staList.begin (); j != m_staList.end (); j++)
-                {
-                  if (j->second == from)
-                    {
-                      m_staList.erase (j);
-                      break;
-                    }
-                }
-              for (std::list<Mac48Address>::const_iterator j = m_nonErpStations.begin (); j != m_nonErpStations.end (); j++)
-                {
-                  if ((*j) == from)
-                    {
-                      m_nonErpStations.erase (j);
-                      break;
-                    }
-                }
-              for (std::list<Mac48Address>::const_iterator j = m_nonHtStations.begin (); j != m_nonHtStations.end (); j++)
-                {
-                  if ((*j) == from)
-                    {
-                      m_nonHtStations.erase (j);
-                      break;
-                    }
-                }
-              for (std::list<Mac48Address>::const_iterator j = m_cfPollingList.begin (); j != m_cfPollingList.end (); ++j)
+              for (auto it = m_staList.begin (); it != m_staList.end (); ++it)
                 {
-                  if ((*j) == from)
+                  if (it->second == from)
                     {
-                      m_cfPollingList.erase (j);
+                      m_staList.erase (it);
+                      m_deAssocLogger (it->first, it->second);
+                      m_addressIdMap.erase (from);
+                      if (m_stationManager->GetDsssSupported (from) && !m_stationManager->GetErpOfdmSupported (from))
+                        {
+                          m_numNonErpStations--;
+                        }
+                      if (!m_stationManager->GetHtSupported (from))
+                        {
+                          m_numNonHtStations--;
+                        }
+                      UpdateShortSlotTimeEnabled ();
+                      UpdateShortPreambleEnabled ();
                       break;
                     }
                 }
@@ -1577,13 +1360,17 @@
           m_beaconEvent = Simulator::ScheduleNow (&ApWifiMac::SendOneBeacon, this);
         }
     }
+  NS_ABORT_IF (!TraceConnectWithoutContext ("AckedMpdu", MakeCallback (&ApWifiMac::TxOk, this)));
+  NS_ABORT_IF (!TraceConnectWithoutContext ("MpduResponseTimeout", MakeCallback (&ApWifiMac::TxFailed, this)));
   RegularWifiMac::DoInitialize ();
+  UpdateShortSlotTimeEnabled ();
+  UpdateShortPreambleEnabled ();
 }
 
 bool
 ApWifiMac::GetUseNonErpProtection (void) const
 {
-  bool useProtection = !m_nonErpStations.empty () && m_enableNonErpProtection;
+  bool useProtection = (m_numNonErpStations > 0) && m_enableNonErpProtection;
   m_stationManager->SetUseNonErpProtection (useProtection);
   return useProtection;
 }
@@ -1603,15 +1390,71 @@
   return 0;
 }
 
+const std::map<uint16_t, Mac48Address>&
+ApWifiMac::GetStaList (void) const
+{
+  return m_staList;
+}
+
+uint16_t
+ApWifiMac::GetAssociationId (Mac48Address addr) const
+{
+  auto it = m_addressIdMap.find (addr);
+
+  if (it == m_addressIdMap.end ())
+    {
+      return SU_STA_ID;
+    }
+  return it->second;
+}
+
+uint8_t
+ApWifiMac::GetBufferStatus (uint8_t tid, Mac48Address address) const
+{
+  auto it = m_bufferStatus.find (WifiAddressTidPair (address, tid));
+  if (it == m_bufferStatus.end ()
+      || it->second.timestamp + m_bsrLifetime < Simulator::Now ())
+    {
+      return 255;
+    }
+  return it->second.value;
+}
+
 void
-ApWifiMac::IncrementPollingListIterator (void)
+ApWifiMac::SetBufferStatus (uint8_t tid, Mac48Address address, uint8_t size)
 {
-  NS_LOG_FUNCTION (this);
-  m_itCfPollingList++;
-  if (m_itCfPollingList == m_cfPollingList.end ())
+  if (size == 255)
+    {
+      // no point in storing an unspecified size
+      m_bufferStatus.erase (WifiAddressTidPair (address, tid));
+    }
+  else
+    {
+      m_bufferStatus[WifiAddressTidPair (address, tid)] = {size, Simulator::Now ()};
+    }
+}
+
+uint8_t
+ApWifiMac::GetMaxBufferStatus (Mac48Address address) const
+{
+  uint8_t maxSize = 0;
+  bool found = false;
+
+  for (uint8_t tid = 0; tid < 8; tid++)
+    {
+      uint8_t size = GetBufferStatus (tid, address);
+      if (size != 255)
+        {
+          maxSize = std::max (maxSize, size);
+          found = true;
+        }
+    }
+
+  if (found)
     {
-      m_itCfPollingList = m_cfPollingList.begin ();
+      return maxSize;
     }
+  return 255;
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ap-wifi-mac.h ns-3.34/src/wifi/model/ap-wifi-mac.h
--- ns-3.33/src/wifi/model/ap-wifi-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ap-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -23,7 +23,8 @@
 #ifndef AP_WIFI_MAC_H
 #define AP_WIFI_MAC_H
 
-#include "infrastructure-wifi-mac.h"
+#include "regular-wifi-mac.h"
+#include <unordered_map>
 
 namespace ns3 {
 
@@ -44,7 +45,7 @@
  * Handle association, dis-association and authentication,
  * of STAs within an infrastructure BSS.
  */
-class ApWifiMac : public InfrastructureWifiMac
+class ApWifiMac : public RegularWifiMac
 {
 public:
   /**
@@ -56,13 +57,12 @@
   ApWifiMac ();
   virtual ~ApWifiMac ();
 
-  // Implementations of pure virtual methods, or overridden from base class.
-  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager);
-  void SetLinkUpCallback (Callback<void> linkUp);
-  void Enqueue (Ptr<Packet> packet, Mac48Address to);
-  void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from);
-  bool SupportsSendFrom (void) const;
-  void SetAddress (Mac48Address address);
+  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager) override;
+  void SetLinkUpCallback (Callback<void> linkUp) override;
+  void Enqueue (Ptr<Packet> packet, Mac48Address to) override;
+  void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from) override;
+  bool SupportsSendFrom (void) const override;
+  void SetAddress (Mac48Address address) override;
 
   /**
    * \param interval the interval between two beacon transmissions.
@@ -72,37 +72,7 @@
    * \return the interval between two beacon transmissions.
    */
   Time GetBeaconInterval (void) const;
-  /**
-   * \param duration the maximum duration for the CF period.
-   */
-  void SetCfpMaxDuration (Time duration);
-  /**
-   * \return the maximum duration for the CF period.
-   */
-  Time GetCfpMaxDuration (void) const;
-  /**
-   * Determine whether short slot time should be enabled or not in the BSS.
-   * Typically, true is returned only when there is no non-ERP stations associated
-   * to the AP, and that short slot time is supported by the AP and by all other
-   * ERP stations that are associated to the AP. Otherwise, false is returned.
-   *
-   * \returns whether short slot time should be enabled or not in the BSS.
-   */
-  bool GetShortSlotTimeEnabled (void) const;
-  /**
-   * Determine whether short preamble should be enabled or not in the BSS.
-   * Typically, true is returned only when the AP and all associated
-   * stations support short PHY preamble.
-   *
-   * \returns whether short preamble should be enabled or not in the BSS.
-   */
-  bool GetShortPreambleEnabled (void) const;
-  /**
-   * Determine whether non-Greenfield HT stations are present or not.
-   *
-   * \returns whether non-Greenfield HT stations are present or not.
-   */
-  bool IsNonGfHtStasPresent (void) const;
+
   /**
    * Determine the VHT operational channel width (in MHz).
    *
@@ -121,27 +91,79 @@
    */
   int64_t AssignStreams (int64_t stream);
 
+  /**
+   * Get a const reference to the map of associated stations. Each station is
+   * specified by an (association ID, MAC address) pair. Make sure not to use
+   * the returned reference after that this object has been deallocated.
+   *
+   * \return a const reference to the map of associated stations
+   */
+  const std::map<uint16_t, Mac48Address>& GetStaList (void) const;
+  /**
+   * \param addr the address of the associated station
+   * \return the Association ID allocated by the AP to the station, SU_STA_ID if unallocated
+   */
+  uint16_t GetAssociationId (Mac48Address addr) const;
+
+  /**
+   * Return the value of the Queue Size subfield of the last QoS Data or QoS Null
+   * frame received from the station with the given MAC address and belonging to
+   * the given TID.
+   *
+   * The Queue Size value is the total size, rounded up to the nearest multiple
+   * of 256 octets and expressed in units of 256 octets, of all  MSDUs and A-MSDUs
+   * buffered at the STA (excluding the MSDU or A-MSDU of the present QoS Data frame).
+   * A queue size value of 254 is used for all sizes greater than 64 768 octets.
+   * A queue size value of 255 is used to indicate an unspecified or unknown size.
+   * See Section 9.2.4.5.6 of 802.11-2016
+   *
+   * \param tid the given TID
+   * \param address the given MAC address
+   * \return the value of the Queue Size subfield
+   */
+  uint8_t GetBufferStatus (uint8_t tid, Mac48Address address) const;
+  /**
+   * Store the value of the Queue Size subfield of the last QoS Data or QoS Null
+   * frame received from the station with the given MAC address and belonging to
+   * the given TID.
+   *
+   * \param tid the given TID
+   * \param address the given MAC address
+   * \param size the value of the Queue Size subfield
+   */
+  void SetBufferStatus (uint8_t tid, Mac48Address address, uint8_t size);
+  /**
+   * Return the maximum among the values of the Queue Size subfield of the last
+   * QoS Data or QoS Null frames received from the station with the given MAC address
+   * and belonging to any TID.
+   *
+   * \param address the given MAC address
+   * \return the maximum among the values of the Queue Size subfields
+   */
+  uint8_t GetMaxBufferStatus (Mac48Address address) const;
 
 private:
-  void Receive (Ptr<WifiMacQueueItem> mpdu);
+  void Receive (Ptr<WifiMacQueueItem> mpdu)  override;
   /**
    * The packet we sent was successfully received by the receiver
    * (i.e. we received an Ack from the receiver).  If the packet
    * was an association response to the receiver, we record that
    * the receiver is now associated with us.
    *
-   * \param hdr the header of the packet that we successfully sent
+   * \param mpdu the MPDU that we successfully sent
    */
-  void TxOk (const WifiMacHeader &hdr);
+  void TxOk (Ptr<const WifiMacQueueItem> mpdu);
   /**
    * The packet we sent was successfully received by the receiver
    * (i.e. we did not receive an Ack from the receiver).  If the packet
    * was an association response to the receiver, we record that
    * the receiver is not associated with us yet.
    *
-   * \param hdr the header of the packet that we failed to sent
+   * \param timeoutReason the reason why the TX timer was started (\see WifiTxTimer::Reason)
+   * \param mpdu the MPDU that we failed to sent
+   * \param txVector the TX vector used to send the MPDU
    */
-  void TxFailed (const WifiMacHeader &hdr);
+  void TxFailed (uint8_t timeoutReason, Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector);
 
   /**
    * This method is called to de-aggregate an A-MSDU and forward the
@@ -151,7 +173,7 @@
    *
    * \param mpdu the MPDU containing the A-MSDU.
    */
-  void DeaggregateAmsduAndForward (Ptr<WifiMacQueueItem> mpdu);
+  void DeaggregateAmsduAndForward (Ptr<WifiMacQueueItem> mpdu) override;
   /**
    * Forward the packet down to DCF/EDCAF (enqueue the packet). This method
    * is a wrapper for ForwardDown with traffic id.
@@ -191,18 +213,6 @@
    * Forward a beacon packet to the beacon special DCF.
    */
   void SendOneBeacon (void);
-  /**
-   * Determine what is the next PCF frame and trigger its transmission.
-   */
-  void SendNextCfFrame (void);
-  /**
-   * Send a CF-Poll packet to the next polling STA.
-   */
-  void SendCfPoll (void);
-  /**
-   * Send a CF-End packet.
-   */
-  void SendCfEnd (void);
 
   /**
    * Return the Capability information of the current AP.
@@ -223,12 +233,6 @@
    */
   EdcaParameterSet GetEdcaParameterSet (void) const;
   /**
-   * Return the CF parameter set of the current AP.
-   *
-   * \return the CF parameter set that we support
-   */
-  CfParameterSet GetCfParameterSet (void) const;
-  /**
    * Return the HT operation of the current AP.
    *
    * \return the HT operation that we support
@@ -265,6 +269,21 @@
    * \param enable enable or disable beacon generation
    */
   void SetBeaconGeneration (bool enable);
+
+  /**
+   * Update whether short slot time should be enabled or not in the BSS.
+   * Typically, short slot time is enabled only when there is no non-ERP station
+   * associated  to the AP, and that short slot time is supported by the AP and by all
+   * other ERP stations that are associated to the AP. Otherwise, it is disabled.
+   */
+  void UpdateShortSlotTimeEnabled (void);
+  /**
+   * Update whether short preamble should be enabled or not in the BSS.
+   * Typically, short preamble is enabled only when the AP and all associated
+   * stations support short PHY preamble. Otherwise, it is disabled.
+   */
+  void UpdateShortPreambleEnabled (void);
+
   /**
    * Return whether protection for non-ERP stations is used in the BSS.
    *
@@ -272,14 +291,9 @@
    *         false otherwise
    */
   bool GetUseNonErpProtection (void) const;
-  /**
-   * Increment the PCF polling list iterator to indicate
-   * that the next polling station can be polled.
-   */
-  void IncrementPollingListIterator (void);
 
-  void DoDispose (void);
-  void DoInitialize (void);
+  void DoDispose (void) override;
+  void DoInitialize (void) override;
 
   /**
    * \return the next Association ID to be allocated by the AP
@@ -288,16 +302,38 @@
 
   Ptr<Txop> m_beaconTxop;                    //!< Dedicated Txop for beacons
   bool m_enableBeaconGeneration;             //!< Flag whether beacons are being generated
+  Time m_beaconInterval;                     //!< Beacon interval
   EventId m_beaconEvent;                     //!< Event to generate one beacon
-  EventId m_cfpEvent;                        //!< Event to generate one PCF frame
   Ptr<UniformRandomVariable> m_beaconJitter; //!< UniformRandomVariable used to randomize the time of the first beacon
   bool m_enableBeaconJitter;                 //!< Flag whether the first beacon should be generated at random time
   std::map<uint16_t, Mac48Address> m_staList; //!< Map of all stations currently associated to the AP with their association ID
-  std::list<Mac48Address> m_nonErpStations;  //!< List of all non-ERP stations currently associated to the AP
-  std::list<Mac48Address> m_nonHtStations;   //!< List of all non-HT stations currently associated to the AP
-  std::list<Mac48Address> m_cfPollingList;   //!< List of all PCF stations currently associated to the AP
-  std::list<Mac48Address>::iterator m_itCfPollingList; //!< Iterator to the list of all PCF stations currently associated to the AP
+  /// Maps MAC addresses of associated stations to their association ID
+  std::unordered_map<Mac48Address, uint16_t, WifiAddressHash> m_addressIdMap;
+  uint16_t m_numNonErpStations;              //!< Number of non-ERP stations currently associated to the AP
+  uint16_t m_numNonHtStations;               //!< Number of non-HT stations currently associated to the AP
+  bool m_shortSlotTimeEnabled;               //!< Flag whether short slot time is enabled within the BSS
+  bool m_shortPreambleEnabled;               //!< Flag whether short preamble is enabled in the BSS
   bool m_enableNonErpProtection;             //!< Flag whether protection mechanism is used or not when non-ERP STAs are present within the BSS
+  Time m_bsrLifetime;                        //!< Lifetime of Buffer Status Reports
+  /// store value and timestamp for each Buffer Status Report
+  typedef struct
+  {
+    uint8_t value;  //!< value of BSR
+    Time timestamp; //!< timestamp of BSR
+  } bsrType;
+  /// Per (MAC address, TID) buffer status reports
+  std::unordered_map<WifiAddressTidPair, bsrType, WifiAddressTidHash> m_bufferStatus;
+
+  /**
+   * TracedCallback signature for association/deassociation events.
+   *
+   * \param aid the AID of the station
+   * \param address the MAC address of the station
+   */
+  typedef void (* AssociationCallback)(uint16_t aid, Mac48Address address);
+
+  TracedCallback<uint16_t /* AID */, Mac48Address> m_assocLogger;   ///< association logger
+  TracedCallback<uint16_t /* AID */, Mac48Address> m_deAssocLogger; ///< deassociation logger
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-agreement.cc ns-3.34/src/wifi/model/block-ack-agreement.cc
--- ns-3.33/src/wifi/model/block-ack-agreement.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-agreement.cc	2021-07-14 10:31:07.000000000 -0700
@@ -165,4 +165,37 @@
   return (m_htSupported == 1) ? true : false;
 }
 
+BlockAckType
+BlockAckAgreement::GetBlockAckType (void) const
+{
+  if (!m_htSupported)
+    {
+      return BlockAckType::BASIC;
+    }
+  // Multi-TID Block Ack is not currently supported
+  if (m_bufferSize > 64)
+    {
+      return {BlockAckType::COMPRESSED, {32}};
+    }
+  return {BlockAckType::COMPRESSED, {8}};
+}
+
+BlockAckReqType
+BlockAckAgreement::GetBlockAckReqType (void) const
+{
+  if (!m_htSupported)
+    {
+      return BlockAckReqType::BASIC;
+    }
+  // Multi-TID Block Ack Request is not currently supported
+  return BlockAckReqType::COMPRESSED;
+}
+
+std::size_t
+BlockAckAgreement::GetDistance (uint16_t seqNumber, uint16_t startingSeqNumber)
+{
+  NS_ASSERT (seqNumber < SEQNO_SPACE_SIZE && startingSeqNumber < SEQNO_SPACE_SIZE);
+  return (seqNumber - startingSeqNumber + SEQNO_SPACE_SIZE) % SEQNO_SPACE_SIZE;
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-agreement.h ns-3.34/src/wifi/model/block-ack-agreement.h
--- ns-3.33/src/wifi/model/block-ack-agreement.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-agreement.h	2021-07-14 10:31:07.000000000 -0700
@@ -23,6 +23,7 @@
 
 #include "ns3/mac48-address.h"
 #include "ns3/event-id.h"
+#include "block-ack-type.h"
 
 namespace ns3 {
 /**
@@ -33,7 +34,7 @@
 {
   /// Provide access to MacLow class
   friend class MacLow;
-
+  friend class HtFrameExchangeManager;
 
 public:
   /**
@@ -43,7 +44,7 @@
    * \param tid the TID
    */
   BlockAckAgreement (Mac48Address peer, uint8_t tid);
-  ~BlockAckAgreement ();
+  virtual ~BlockAckAgreement ();
   /**
    * Set buffer size.
    *
@@ -111,7 +112,7 @@
    *
    * \return starting sequence number
    */
-  uint16_t GetStartingSequence (void) const;
+  virtual uint16_t GetStartingSequence (void) const;
   /**
    * Return the starting sequence control
    *
@@ -151,6 +152,27 @@
    *         false otherwise
    */
   bool IsHtSupported (void) const;
+  /**
+   * Get the type of the Block Acks sent by the recipient of this agreement.
+   *
+   * \return the type of the Block Acks sent by the recipient of this agreement
+   */
+  BlockAckType GetBlockAckType (void) const;
+  /**
+   * Get the type of the Block Ack Requests sent by the originator of this agreement.
+   *
+   * \return the type of the Block Ack Requests sent by the originator of this agreement
+   */
+  BlockAckReqType GetBlockAckReqType (void) const;
+  /**
+   * Get the distance between the given starting sequence number and the
+   * given sequence number.
+   *
+   * \param seqNumber the given sequence number
+   * \param startingSeqNumber the given starting sequence number
+   * \return the distance of the given sequence number from the given starting sequence number
+   */
+  static std::size_t GetDistance (uint16_t seqNumber, uint16_t startingSeqNumber);
 
 
 protected:
